<?php
/*
OekakiPoteto 5.x Copyright 2000-2002 RanmaGuy (Theo Chakkapark, http://suteki.nu) and Marcello Basta-Forte (http://marcello.cellosoft.com). Modification to the files are permitted as long as my name remains on the files.

Wacintaki Poteto modifications Copyright 2004-2010 Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 1.5.0 - Last modified 3/4/2010

WARNING:
Do NOT put sensitive information into this script!
*/


// Load bootstrap
define ('BOOT', 1);
require ('boot.php');


// Diagnosics backdoor.
$testinfo = (w_gpc('pass') == $cfg['salt']) ? TRUE : FALSE;
if (!$testinfo && !$flags['owner']) {
	report_err ( t('testvar1'));
}
if (isset ($_GET['php'])) {
	db_close();
	phpinfo();
	exit();
}


// Get member
$member_info = array();


// Get DB
$db_info = array();
$limit_quanity = 6;
{
	$result = db_query ("SELECT miscstring FROM {$db_p}oekakimisc WHERE miscname='dbversion'");
	$db_info['DB version'] = db_result ($result, 0);

	// "$si" is from db_layer.php
	if ($si) {
		$db_info['DB API'] = 'MySQLi (improved, MySQL 5)';
	} else {
		$db_info['DB API'] = 'MySQL (standard, MySQL 4+5)';
	}

	$result = db_query ("SELECT COUNT(ID_2) FROM {$db_p}oekakidta");
	$db_info['Total pics'] = (int) db_result ($result, 0)." (out of {$cfg['pic_store']})";

	$result = db_query ("SELECT COUNT(ID_2) FROM {$db_p}oekakidta WHERE archive=1");
	$db_info['Archives'] = (int) db_result ($result, 0);

	$result = db_query ("SELECT COUNT(ID_2) FROM {$db_p}oekakidta WHERE postlock=0");
	$db_info['WIPs or recovery'] = (int) db_result ($result, 0);

	$result = db_query ("SELECT miscvalue FROM {$db_p}oekakimisc WHERE miscname='piccount'");
	$db_info['Current picture number'] = (int) db_result ($result, 0);

	$temp = array();
	$result = db_query ("SELECT PIC_ID FROM {$db_p}oekakidta ORDER BY postdate DESC LIMIT {$limit_quanity}");
	if ($result) {
		$rows = db_num_rows ($result);
		for ($i = 0; $i < $rows; $i++) {
			$temp[] = (int) db_result ($result, $i);
		}
		$temp[] = '(Newest first)';
		$db_info['Newest '.$limit_quanity.' pictures'] = make_list($temp, ', ');
	}

	$temp = array();
	$result = db_query ("SELECT PIC_ID FROM {$db_p}oekakidta ORDER BY postdate ASC LIMIT {$limit_quanity}");
	if ($result) {
		$rows = db_num_rows ($result);
		for ($i = 0; $i < $rows;  $i++) {
			$temp[] = (int) db_result ($result, $i);
		}
		$temp[] = '(Oldest first)';
		$db_info['Oldest '.$limit_quanity.' pictures'] = make_list($temp, ', ');
	}
}


// Get picture stats
{
	function getTotalPer($in, $total) {
		if ($total == 0) {
			return $in;
		}

		$out = ((float) $in / (float) $total) * 100.0;
		return ($in.' ('.sprintf ('%5.1f', $out).'%)');
	}

	$f_total = 0;
	$f_kilo  = 0;
	$f_img   = 0;
	$f_anim  = 0;
	$f_other = 0;
	$f_png   = 0;
	$f_gif   = 0;
	$f_jpg   = 0;
	$f_pch   = 0;
	$f_oeb   = 0;
	$f_chi   = 0;
	$err = '';

	if (! ($handle = opendir ($cfg['op_pics']))) {
		$err = 'Cannot read folder';
	} else { 
		while (FALSE !== ($file = readdir ($handle))) {
			$dot = strpos ($file, '.');

			// Don't include hidden files or text/code files
			if ($file != 'index.php' && $dot !== FALSE && $dot != 0) {
				$f_total++;
				$size = filesize ($cfg['op_pics'].'/'.$file);
				if ($size > 0) {
					// PHP doesn't support long (!), so use KB, so we don't overflow
					$f_kilo += intval (($size / 1024));
				}

				// Only 3 char extensions
				$ext = substr ($file, -3);

				switch ($ext) {
					case 'gif':
						$f_gif++;
						$f_img++;
						break;

					case 'jpg':
						$f_jpg++;
						$f_img++;
						break;

					case 'png':
						$f_png++;
						$f_img++;
						break;

					case 'pch':
						$f_pch++;
						$f_anim++;
						break;

					case 'oeb':
						$f_oeb++;
						$f_anim++;
						break;

					case 'chi':
						$f_chi++;
						$f_anim++;
						break;

					default:
						$f_other++;
						break;
				}
			}
		}
		closedir ($handle);


		// Div by zero
		if ($f_total < 1) {
			$err = 'Folder empty';
		} else {
			$total_size = '';
			$avg_size   = '';

			// Totals
			$total_size .= $f_kilo.'KB';
			$t_megabytes = intval ($f_kilo / 1024);
			if ($t_megabytes > 9) {
				$total_size .= ' ('.$t_megabytes.'MB)';
			}

			// Averages
			$avg_size .= intval ($f_kilo / $f_total).'KB';
			$avg_megabytes = ((float) $f_kilo / (float) $f_total / 1024.0);
		}
	}
}


// Get Locks
{
	$lock_info = array (
		"./" => 0,
		"./{$cfg['op_pics']}/"       => 0,
		"./{$cfg['tpl_path']}/"      => 0,
		"./{$cfg['res_path']}/"      => 0,
		"./{$cfg['avatar_folder']}/" => 0,
		"./config.php" => 0,
		"./dbconn.php" => 0,
//		"./announce.php" => 0,
		"./{$cfg['res_path']}/banner.php" => 0,
		"./{$cfg['res_path']}/hosts.txt"  => 0,
		"./{$cfg['res_path']}/ips.txt"    => 0,
		"./{$cfg['res_path']}/notice.php" => 0,
		"./{$cfg['res_path']}/rules.php"  => 0
	);

	foreach ($lock_info as $name => $value) {
		if (file_exists ($name)) {
			if (!is_writable ($name)) {
				$lock_info[$name] = 1;
			}
		} else {
			$lock_info[$name] = 2;
		}
	}
}


// Get files
// Number of files, sizes (pictures, avatars, average size)


include ('header.php');


?>
<div id="contentmain">
	<h1 class="header">
		<?php tt('dbinfo');?>
	</h1>
	<div class="infotable">
		<table class="infomain">
<?php foreach ($db_info as $name => $value) { ?>
		<tr>
		<td class="infoask">
			<?php echo $name; ?>:
		</td>
		<td class="infoenter">
			<?php echo $value; ?> 
		</td>
		</tr>
<?php }
unset ($db_info);
?>
		<tr>
		<td colspan="2">&nbsp;</td>
		</tr>

		<tr>
		<td class="infoask">
			SQL direct calls:
		</td>
		<td class="infoenter">
<?php if (file_exists ('sqltest.php')) { ?>
			Available <a href="sqltest.php">(click here)</a>
<?php } else { ?>
			N/A
<?php } ?>
		</td>
		</tr>
		</table>
	</div>
	<br />


	<h1 class="header">
		<?php tt('word_config');?>
	</h1>
	<div class="infotable">
		<table class="infomain">
		<tr>
		<td class="infoask">
			PHP Information:
		</td>
		<td class="infoenter">
			<?php echo (phpversion()); ?> <a href="<?php echo $_SERVER['PHP_SELF'].'?php=1';?>">(click for more details)</a>
		</td>
		</tr>

		<tr>
		<td colspan="2">&nbsp;</td>
		</tr>

		<tr>
		<td class="infoask">
			<?php tt('configver');?>:
		</td>
		<td class="infoenter">
			<?php echo $cfg['version'] ?> 
		</td>
		</tr>

		<tr>
		<td class="infoask">
			<?php tt('word_contact');?>:
		</td>
		<td class="infoenter">
			<?php echo $cfg['op_email'] ?> 
		</td>
		</tr>

		<tr>
		<td class="infoask">
			<?php tt('pathtoop');?>:
		</td>
		<td class="infoenter">
			<?php echo $cfg['op_url'] ?> 
		</td>
		</tr>

		<tr>
		<td class="infoask">
			Cookie path:
		</td>
		<td class="infoenter">
			<?php ne_echo ($cookie_path, '(empty)'); ?> 
		</td>
		</tr>

		<tr>
		<td class="infoask">
			Cookie domain:
		</td>
		<td class="infoenter">
			<?php ne_echo ($cookie_domain, '(empty)'); ?> 
		</td>
		</tr>

		<tr>
		<td class="infoask">
			<?php tt('cookielife');?>:
		</td>
		<td class="infoenter">
			<?php echo $cookie_life ?> <?php tt('word_seconds');?> (~ <?php echo intval ($cookie_life / 86400); ?> <?php tt('word_days');?>)
		</td>
		</tr>

		<tr>
		<td class="infoask">
			<?php tt('publicimg');?>:
		</td>
		<td class="infoenter">
			<?php echo $cfg['public_retouch'] ?> 
		</td>
		</tr>

		<tr>
		<td class="infoask">
			<?php tt('safetysaves');?>:
		</td>
		<td class="infoenter">
			<?php echo $cfg['safety_saves'] ?> (<?php echo intval ($cfg['safety_storetime']); ?> <?php tt('word_days');?>)
		</td>
		</tr>
		</table>
	</div>
	<br />


	<h1 class="header">
		Pictures folder
	</h1>
	<div class="infotable">
<?php if (!empty ($err)) { ?>
		<table class="infomain">
		<tr>
		<td class="infoask">
			Notice:
		</td>
		<td class="infoenter">
			<?php echo $err; ?> 
		</td>
		</tr>
		</table>
<?php } else { ?>
		<table class="infomain">
		<tr>
		<td class="infoask">
			Folder:
		</td>
		<td class="infoenter">
			<?php echo $cfg['op_pics'];?> 
		</td>
		</tr>

		<tr>
		<td class="infoask">
			Total files:
		</td>
		<td class="infoenter">
			<?php echo $f_total;?> 
		</td>
		</tr>

		<tr>
		<td class="infoask">
			Total space used:
		</td>
		<td class="infoenter">
			<?php echo $total_size;?> 
		</td>
		</tr>

		<tr>
		<td class="infoask">
			Average file size:
		</td>
		<td class="infoenter">
			<?php echo $avg_size;?> 
		</td>
		</tr>

		<tr>
		<td colspan="2">&nbsp;</td>
		</tr>

		<tr>
		<td class="infoask">
			Images:
		</td>
		<td class="infoenter">
			<?php echo getTotalPer($f_img, $f_total);?> 
		</td>
		</tr>

		<tr>
		<td class="infoask">
			Animations:
		</td>
		<td class="infoenter">
			<?php echo getTotalPer($f_anim, $f_total);?> 
		</td>
		</tr>

		<tr>
		<td colspan="2">&nbsp;</td>
		</tr>

		<tr>
		<td class="infoask">
			.PNG:
		</td>
		<td class="infoenter">
			<?php echo $f_png;?> 
		</td>
		</tr>

		<tr>
		<td class="infoask">
			.JPG:
		</td>
		<td class="infoenter">
			<?php echo $f_jpg;?> 
		</td>
		</tr>

		<tr>
		<td class="infoask">
			.GIF:
		</td>
		<td class="infoenter">
			<?php echo $f_gif;?> 
		</td>
		</tr>

		<tr>
		<td class="infoask">
			.PCH:
		</td>
		<td class="infoenter">
			<?php echo $f_pch;?> 
		</td>
		</tr>

		<tr>
		<td class="infoask">
			.OEB:
		</td>
		<td class="infoenter">
			<?php echo $f_oeb;?> 
		</td>
		</tr>

		<tr>
		<td class="infoask">
			.CHI:
		</td>
		<td class="infoenter">
			<?php echo $f_chi;?> 
		</td>
		</tr>

		<tr>
		<td class="infoask">
			Other filetypes:
		</td>
		<td class="infoenter">
			<?php echo $f_other;?> 
		</td>
		</tr>
		</table>
<?php } ?>
	</div>
	<br />


	<h1 class="header">
		<?php tt('word_locks');?>
	</h1>
	<div class="infotable">
		<table class="infomain">
<?php foreach ($lock_info as $name => $value) { ?>
		<tr>
		<td class="infoask">
			<?php echo $name; ?> 
		</td>
		<td class="infoenter">
			<?php
			if ($value == 0) {
				echo 'OK';
			} elseif ($value == 1) {
				echo '<strong>'.t('word_locked').'</strong>';
			} else {
				echo '<strong>'.t('word_missing').'</strong>';
			}
			?> 
		</td>
		</tr>
<?php }
unset ($lock_info);
?>

		</table>
	</div>
	<br />


</div>
<?php

include ('footer.php');
exit();